#!/bin/sh
#
# Sophos Anti-Virus for Unix installation script Version 2.30
# Copyright (c) 1998,2002 Sophos Plc, Oxford, England
#
if [ "$1" = -readytogo ]; then
   shift
else
   
   {
      ksh -c 'exit 0'
   } >/dev/null 2>/dev/null      && ENV= exec ksh $0 -readytogo "$@"
   {
      bash -c 'exit 0'
   } >/dev/null 2>/dev/null      && ENV= exec bash $0 -readytogo "$@"
   os=`uname -s 2>/dev/null`
   if [ "$os" != Linux ] && [ "$os" != FreeBSD ]; then
      echo "Error: Could not find a suitable shell (ksh or bash)"
      echo "       with which to run the installation script."
      exit 1
   fi
   {
      sh -c 'exit 0'
   } >/dev/null 2>/dev/null   && ENV= exec sh $0 -readytogo "$@"
fi
VAcp()
{
   
   
   
   
   
   [ ${#} -lt 2 ] && error Internal script problem '(VAcp())'
   rm -f $2
   cp -f $1 $2 || error Cannot copy $1 to $2
   fecho 1 $1 copied to $2
   [ "$3" ] && VAchmod $3 $2
   [ "$4" ] && VAchown $4 $2
   [ "$5" ] && VAchgrp $5 $2
}
VAchmod()
{  
   chmod $1 $2 || error Cannot chmod $2 to $1
}
VAchown()
{  
   chown $1 $2 || error Cannot chown $2 to $1
}
VAchgrp()
{  
   chgrp $1 $2 || error Cannot chgrp $2 to $1
}
VAmkdir()
{
   
   
   
   
   
   
   if [ ! -d $1 ]; then
      if mkdir -p $1 ; then
         fecho 1 Created directory $1
      else
         error Could not create directory $1
      fi
   fi
   [ "$2" ] && VAchmod $2 $1
   [ "$3" ] && VAchown $3 $1
   [ "$4" ] && VAchgrp $4 $1
}
VAln()
{
   
   rm -f "$2"
   if ln -s "$1" "$2" >/dev/null 2>&1; then
      fecho 1 "$1" symlinked to "$2"
   else
      error Unable to make symbolic link from "$1" to "$2."
   fi
}
VAexit()
{
   
   rm -f /tmp/sav_install.$$ 
   exit $1
}
error()
{
   
   fecho - 'Error:  ' $*
   VAexit 1
}
fecho()
{
   
   
   
   
   
   
   
   case "$verbose,$1" in
      [0-9],[0-9]) [ $verbose -ge $1 ] || return; shift;;
   esac
   
   
   
   
   case $1 in
      '') echo; return;;
      +) shift
         p='         '
         l="         $1";;
      -) shift
         p='         '
         l="$1";;
      *) p=
         l="$1";;
   esac
   shift
   for w in "$@"
   do
      case "$l $w" in
      ????????????????????????????????????????????????????????????????????????????????*)
         
         echo "$l"
         l="$p$w";;
      *) l="$l $w";;
      esac
   done
   echo "$l"
}
print_usage()
{
   echo "Usage: install.sh [-h] [-v] "
   echo "                  [-d <dir>] [-b <rel>] [-l <rel>] [-m <rel>] [-s <rel>]"
   echo "                  [-i [<dir>] | -ni] [-ssi | -nssi] [-idc | -nidc]"
   echo ""
   echo "  -h        This message"
   echo "  -v        Verbose operation (Recommended for first time installation)"
   echo ""
   echo "  -d dir    Directory prefix for the following four options (default /usr/local)"
   echo "  -b dir    Binary directory            (relative to prefix, default bin)"
   echo "  -l dir    Library directory           (relative to prefix, default lib)"
   echo "  -m dir    Manual page directory       (relative to prefix, default man)"
   echo "  -s dir    Virus data directory        (relative to prefix, default sav)"
   echo ""
   echo "  -i [dir]  InterCheck directory (defaults to /var/spool/intercheck"
   echo "            or the ROOTDIRECTORY given in /etc/icheckd.conf, if that exists)"
   echo "  -ni       Do not install InterCheck"
   echo "  -ssi      Stop & start InterCheck server after installation"
   echo "  -nssi     Do not stop & start InterCheck (default)"
   echo "  -idc      Install InterCheck for diskless clients"
   echo "  -nidc     Do not install InterCheck for diskless clients (default)"
   echo "  -rm       Remove old libraries and virus data files (default)"
   echo "  -nrm      Do not remove old libraries and virus data files"
   echo ""
   echo "Example: install.sh -v -d /usr"
   echo "Use install.sh with no options for a default installation in /usr/local."
}
which()
{
   
   
   
   
   i=$IFS 
   IFS=:
   for d in $PATH; do
      if [ -x $d/$1 ]; then
         echo $d/$1
         IFS=$i 
         return 0
      fi
   done
   IFS=$i
   return 1
}
declareInitVariables()
{  
   
   bin_install_dir="bin"            
   config_file=                     
   configured_ic='set below'        
   existence_test=-e                
   finalWarning=                    
   freebsd_ver=                     
   ic4_tarball=                     
   icheckd_conf="/etc/icheckd.conf" 
   inpath=                          
   install_intercheck=              
   install_lists=                   
   install_prefix=/usr/local        
   intercheck_pid='set below'       
   intercheck_root='set below'      
   isLinux=                         
   lib_install_dir="lib"            
   libpathname=LD_LIBRARY_PATH      
   libsavi_file=                    
   man_install_dir="man"            
   mandirbodge=                     
   platform=                        
   product_name=                    
   root_user="root"                 
   sav_install_dir="sav"            
   start_icheckd=no                 
   stop_start_icheckd=              
   sweep_group=sweep                
   sweep_user=sweep                 
   tab="	" 
   vdl_file=                        
   verbose=0                        
   remove_old_versions=yes          
   
   
   case $tab in *\ * | '') error \$tab is not the tab character.; esac
   configured_ic=/var/spool/intercheck
   
   if [  -r $icheckd_conf ]; then
      
      
      l=`egrep -i "^[ $TAB]*rootdirectory" $icheckd_conf`
      test "$l" && configured_ic="`echo $l | sed -e 's/^.*= *//' -e 's/ *$//'`"
   fi
   intercheck_pid=
   
   if [ -f "$configured_ic/comms/ic.sta" ]; then
      
      p=`head -1 "$configured_ic/comms/ic.sta"`
      if    test "$p" \
         && (   ps -p $p 2> /dev/null | egrep "^ *$p " | egrep "icheckd" >/dev/null 2>&1 \
             || ps $p 2> /dev/null | egrep "^ *$p " | egrep "icheckd" >/dev/null 2>&1
            )
      then 
         intercheck_pid=$p
      fi
   fi
   
   intercheck_root="$configured_ic"
}
checkParameter()
{
   
   
   if [ -z "$1" ] || [ "${1#-}" != "$1" ]; then
      [ "$2" = noerror ] && return 1
      error Expected parameter to option "$1"
   fi
}
scanCommandLine()
{
   while [ -n "$1" ]; do
      case "$1" in
      -d) 
         checkParameter "$2"
         install_prefix="$2"
         shift
         ;;
      -b) 
         checkParameter "$2"
         bin_install_dir="$2"
         shift
         ;;
      -l) 
         checkParameter "$2"
         lib_install_dir="$2"
         shift
         ;;
      -m) 
         checkParameter "$2"
         man_install_dir="$2"
         shift
         ;;
      -s ) 
         checkParameter "$2"
         sav_install_dir="$2"
         shift
         ;;
      -v) verbose=1;;
      
      -i)
         [ "$install_intercheck" = no ] && error "'$1'" conflicts with a previous intercheck switch
         
         install_intercheck=yes
         if checkParameter "$2" noerror; then
            intercheck_root="$2"
            shift
         fi
         ;;
      -ni )
         [ "$install_intercheck" = yes ] && error "'$1'" conflicts with a previous intercheck switch
         install_intercheck=no
         ;;
      -ssi )
         [ "$install_intercheck" = no -o "$stop_start_icheckd" = no ] && error "'$1'" conflicts with a previous intercheck switch
         install_intercheck=yes
         stop_start_icheckd=yes
         ;;
      -nssi )
         stop_start_icheckd=no
         ;;
      -idc )
         [ "$install_intercheck" = no -o "$install_lists" = no ] && error "'$1'" conflictes with a previous intercheck switch
         install_intercheck=yes
         install_lists=yes
         ;;
      -nidc )
         install_lists=no
         ;;
      -rm )
         remove_old_versions=yes
         ;;
      -nrm )
         remove_old_versions=no
         ;;
      -h )
         print_usage
         VAexit 0
         ;;
      
      * )
         echo "Error: Unrecognized option: $1"
         echo
         print_usage
         VAexit 1
         ;;
      esac
      shift
   done
   [ -z "$install_intercheck" ] && install_intercheck=yes
   [ -z "$install_lists" ] && install_lists=no
   [ -z "$stop_start_icheckd" ] && stop_start_icheckd=no
   
   
   [ "${bin_install_dir##/*}" ] && bin_install_dir="${install_prefix%/}/$bin_install_dir"
   [ "${lib_install_dir##/*}" ] && lib_install_dir="${install_prefix%/}/$lib_install_dir"
   [ "${man_install_dir##/*}" ] && man_install_dir="${install_prefix%/}/$man_install_dir"
   [ "${sav_install_dir##/*}" ] && sav_install_dir="${install_prefix%/}/$sav_install_dir"
}
detectPlatform()
{
   
   
   case "`uname -a`" in
   OSF1*alpha*)
      platform=digitalunix
      product_name="Digital UNIX/Alpha"
      ;;
   SunOS*sun4*sparc*)
      platform=solaris.sparc
      product_name="Solaris/SPARC"
      ;;
   SunOS*i86pc*)
      platform=solaris.intel
      product_name="Solaris/Intel"
      ;;
   Linux*86*)
      platform=linux.intel
      product_name="Linux/Intel"
      isLinux=yes
      ;;
   Linux*alpha*)
      platform=linux.alpha
      product_name="Linux/Alpha"
      isLinux=yes
      ;;
   Linux*ppc*)
      platform=linux.ppc
      product_name="Linux/PowerPC"
      isLinux=yes
      ;;
   FreeBSD*)
      platform=freebsd
      product_name="FreeBSD/Intel"
      freebsd_ver=`uname -r | cut -c1`
      
      
      
      ;;
   AIX*)
      platform=aix
      product_name="AIX/PowerPC"
      libpathname=LIBPATH
      ;;
   SCO_SV*i386*)
      platform=scoopenserver
      product_name="SCO OpenServer/Intel"
      mandirbodge=.
      ;;
   UnixWare*i386*)
      platform=scounixware
      product_name="SCO UnixWare/Intel"
      mandirbodge=.
      ;;
   HP-UX*9000*)
      platform=hpux
      product_name="HP-UX/HP-PA"
      existence_test=-a
      libpathname=SHLIB_PATH
      ;;
   *)
      
      error Cannot determine host type.
   esac
}
doAllPossibleChecks()
{
   
   
   
   
   
   
   
   for c in chgrp chmod chown cp kill ln ls mkdir mv ps rm egrep grep head pwd sed sleep tar; do
      which $c >/dev/null || error Could not find \'$c\' in path.
   done
   if [ "$isLinux" ] || [ $platform = freebsd ]; then
      c=ldconfig; which $c >/dev/null || error Could not find \'$c\' in path.
   fi
   
   
   if [ $install_intercheck = yes ]; then
      
      touch /tmp/sav_install.$$ 
      
      if ! chown $sweep_user /tmp/sav_install.$$ >/dev/null 2>&1; then
         
         
         if chown root /tmp/sav_install.$$ >/dev/null 2>&1; then
            error The "'$sweep_user'" user does not exist on your system. Please consult the documentation for more information.
         else
            error You "don't" have the necessary permissions to install Intercheck on your system.  Login as a user with those permissions.  Please consult the documentation for more information.
         fi
      fi
      
      if ! chgrp $sweep_user /tmp/sav_install.$$ >/dev/null 2>&1; then
         error The "'$sweep_group'" group does not exist on your system. Please consult the documentation for more information.
      fi
   fi
   
   for f in sweep icheckd sweep.1* icheckd.1 icheckd.conf.5; do
      [ $existence_test $f ] || error $f does not exist in your install directory. Did you unpack the distribution file correctly\?
   done
   
   if [ $platform = hpux ] || [ $platform = aix ]; then p='libsavi.2.2.*.*'; else p='libsavi.so.2.2.*.*'; fi
   libsavi_file="`echo $p`"
   case "$libsavi_file" in
      
      
      
      
      *\ *) 
         
         libsavi_file=${libsavi_file##* }
         fecho - Warning: There are several shared library files "($p)" in your install directory - Using $libsavi_file.
         ;;
      "$p" | '') 
         error There are no shared library files "($p)" in your install directory.
         ;;
   esac
   
   p='vdl-*.*.dat'
   vdl_file="`echo $p`"
   case "$vdl_file" in
      *\ *)
         
         
         
         
         vdl_file=${vdl_file##* } 
         s=${vdl_file%Beta.dat}   
         [ $s != $vdl_file ] && [ $existence_test $s.dat ] && vdl_file=$s.dat
         fecho - Warning: There are several virus data files "($p)" in your install directory - Using $vdl_file.
         ;;
      "$p" | '')
         error There are no virus data files "($p)" in your install directory.
         ;;
   esac
   
   if [ "$SAV_IDE" ] && [ "$SAV_IDE" != "$sav_install_dir" ]; then
      error "\$SAV_IDE" "(=$SAV_IDE)" is different from the proposed virus data directory "($sav_install_dir)." Please make sure when running sweep or icheckd that SAV_IDE is either unset or equal to the virus data directory. Please unset SAV_IDE for the installation to prevent this error message. '(e.g.:' '"SAV_IDE= ./install.sh [options]"' on bourne 'shells.)'
   fi
   
   if [ $platform = freebsd ]; then
      if file sweep 2>/dev/null | grep ELF >/dev/null; then f=ELF; else f=aout; fi
      case $freebsd_ver,$f in
         2,ELF | [34],aout)
            error This is the wrong version of Sophos Anti-Virus for your version of FreeBSD: Use aout-format for FreeBSD Version 2 and ELF-format for FreeBSD Version 3 or later.
      esac
   fi
   
   if [ $platform = linux.intel ]; then
      e=
      case `ldd ./sweep 2>/dev/null | grep 'libc\.so\.' | sed -e "s/[ $tab]//g" -e 's/=>/,/'` in 
         
         '') e=libc.so.6;;
         
         libc.so.5,notfound) e=libc.so.5;;
         libc.so.6,notfound) e=libc.so.6;;
         
         libc.so.5,*) test -e /lib/libc.so.6 && fecho - Warning: This version of Sophos Anti-Virus uses the shared library libc.so.5. We recommend using the libc6 version of Sophos Anti-Virus instead, since libc.so.6 is also installed on your system.;;
      esac
      [ "$e" ] && error This version of Sophos Anti-Virus uses the shared library $e which is not installed on your system. Install the other linux.intel version of Sophos Anti-Virus.
   fi
   
   case $platform in linux.* | freebsd)
      p="$lib_install_dir/libsavi.so.2.3*"
      f="`echo $p`"
      if [ "$f" != "$p" -a "$f" != "" ]; then
         error There is at least one old Sophos Anti-Virus shared library "($f)" left in the library installation directory. It would interfere with the shared library to be installed now and has to be removed before running install.sh.
      fi
   esac
}
informUser()
{
   if [ $verbose -gt 0 ]; then
      echo Binaries will be installed in \'$bin_install_dir\'
      echo Libraries will be installed in \'$lib_install_dir\'
      echo Manual pages will be installed in \'$man_install_dir\'
      echo Virus data will be installed in \'$sav_install_dir\'
      echo
      
      echo "SWEEP will be installed"
      if [ $install_intercheck = no ]; then
         echo "InterCheck will not be installed"
      else
         echo "InterCheck will be installed"
         echo "InterCheck directory will be '$intercheck_root'"
      fi
      echo
   fi
}
installBinaries()
{
   fecho 1 "===> Installing binaries"
   
   if [ ! -d "$bin_install_dir" ]; then
      VAmkdir "$bin_install_dir" 0755 0 0
   fi
   
   VAcp "sweep" $bin_install_dir/sweep 0755
   
   if [ $install_intercheck = yes ]; then
      try_to_kill_InterCheck
      VAcp "icheckd" "$bin_install_dir/icheckd" 0755
   fi
   
   fecho 1
}
install_libsavi()
{
   fecho 1 "===> Installing shared library"
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   if [ ! -d "$lib_install_dir" ]; then
      VAmkdir "$lib_install_dir" 0755 0 0
   fi
   
   if [ $remove_old_versions = yes ]; then
     
     
     
     
     ls $lib_install_dir | grep "libsavi" >/dev/null 2>/dev/null
     if [ $? -eq 0 ]; then
       
       
       libsavis=`ls -r $lib_install_dir/libsavi*.2.2.*`
       
       
       libkeep=`echo $libsavis | cut -f1,2,3 -d' '`
       
       removelibs=`echo $libsavis | sed -e "s:$libkeep::"`
       
       if [ "$removelibs" != "" ]; then
         fecho 1 Removing old versions of libraries
         rm -f $removelibs
       fi
     fi
   fi
   
   
   VAcp "$libsavi_file" "$lib_install_dir/$libsavi_file" 0555 bin bin
   case $platform in
   aix)
      VAln $libsavi_file $lib_install_dir/libsavi.a;; 
   hpux)
      rm -f /usr/lib/libsavi.sl
      VAln $libsavi_file $lib_install_dir/libsavi.sl;;
   *)
      VAln $libsavi_file $lib_install_dir/libsavi.so.2;;
   esac
   if [ $platform = freebsd ]; then
      ldconfig -R -m $lib_install_dir >/dev/null 2>&1
      fecho 1 ldconfig -R -m $lib_install_dir
   elif [ "$isLinux" ]; then
      ldconfig $lib_install_dir >/dev/null 2>&1
      fecho 1 ldconfig $lib_install_dir
   fi
   fecho 1
}
install_vdl_dat()
{
   fecho 1 "===> Installing virus data"
   if [ ! -d "$sav_install_dir" ]; then
      VAmkdir "$sav_install_dir" 0755 0 0
   fi
   
   if [ $remove_old_versions = yes ]; then
     
     ls $sav_install_dir | grep "vdl-" >/dev/null 2>/dev/null
     if [ $? -eq 0 ]; then
       
       vdlfiles=`ls -r $sav_install_dir/vdl-*`
       
       vdlkeep=`echo $vdlfiles | cut -f1,2,3 -d' '`
       
       removevdls=`echo $vdlfiles | sed -e "s:$vdlkeep::"`
       if [ "$removevdls" != "" ]; then
         fecho 1 Removing old virus data files
         rm -f $removevdls
       fi
     fi
   fi
   
   VAcp $vdl_file "$sav_install_dir/$vdl_file" 0644 bin bin
   VAln $vdl_file "$sav_install_dir/vdl.dat"
   if [ $existence_test /etc/sav.conf ]; then
      config_file=/etc/sav.conf
   elif [ $existence_test /usr/local/sav/sav.conf ]; then
      config_file=/usr/local/sav/sav.conf
   else
      config_file=
   fi
   if [ "$config_file" ]; then
      fecho 1 Adjusting $config_file
      
      <$config_file \
         grep -i -v "^[_= $tab]*SAV[_ $tab]*virus[_ $tab]*data[_ $tab]*directory[_ $tab]*="  |\
         grep -i -v "^[_= $tab]*SAV[_ $tab]*virus[_ $tab]*data[_ $tab]*dir[_ $tab]*="  |\
         grep -i -v "^[_= $tab]*SAV[_ $tab]*directory[_ $tab]*="  \
      >/tmp/sav_install.$$
      cp /tmp/sav_install.$$ "$config_file"
      rm /tmp/sav_install.$$ 
   else
      config_file=/etc/sav.conf
      fecho 1 Creating $config_file
   fi
   echo "SAV virus data directory = $sav_install_dir" >>$config_file
   
   fecho 1
}
installManuals()
{
   if [ "$man_install_dir" ]; then
      fecho 1 "===>" Installing manual pages
      
      VAmkdir "$man_install_dir"                    0755 0 0
      VAmkdir "$man_install_dir/man${mandirbodge}1" 0755 0 0
      VAmkdir "$man_install_dir/man${mandirbodge}5" 0755 0 0
      
      
      
      if [ "$isLinux" ] && [ $existence_test sweep.1.gz ]; then
        VAcp sweep.1.gz "$man_install_dir/man${mandirbodge}1/sweep.1.gz" 0644 bin bin
      else
        VAcp sweep.1 "$man_install_dir/man${mandirbodge}1/sweep.1" 0644 bin bin
      fi
      
      if [ $install_intercheck = yes ]; then
         VAcp icheckd.1 "$man_install_dir/man${mandirbodge}1/icheckd.1" 0644 bin bin
         VAcp icheckd.conf.5 "$man_install_dir/man${mandirbodge}5/icheckd.conf.5" 0644 bin bin
      fi
      
      fecho 1
   fi
   
}
installIC()
{
   [ $install_intercheck = no ] && return
   fecho 1 "===>" Installing InterCheck directories
   
   for t in ICCLIENT.TAR icclient.TAR ICCLIENT.tar icclient.tar; do
      [ $existence_test $t ] && ic4_tarball="`pwd`/$t"
   done
   
   
   
   
   VAmkdir $intercheck_root 0755 $sweep_user $sweep_group
   
   VAmkdir $intercheck_root/comms 1777 $sweep_user $sweep_group
   
   VAmkdir $intercheck_root/infected 0700 $sweep_user $sweep_group
   
   if [ $install_lists = yes ]; then
      VAmkdir $intercheck_root/lists 1777 $sweep_user $sweep_group
   fi
   
   fecho 1
   
   if [ "$ic4_tarball" ]; then
      ( cd $intercheck_root ; tar -oxf $ic4_tarball ) || error Could not extract client files from "$ic4_tarball"
      
      ( cd $intercheck_root; chmod 444 `tar -tf $ic4_tarball` )
      for c in interchk.cfg INTERCHK.CFG INTERCHK.cfg interchk.CFG; do
         [ $existence_test $intercheck_root/$c ] && chmod 644 $intercheck_root/$c
      done
   fi
   if [ $start_icheckd = yes ]; then
     
     $bin_install_dir/icheckd -d
     fecho Restarted InterCheck server based at "$intercheck_root"
   fi
}
try_to_kill_InterCheck()
{
        
   [ $stop_start_icheckd = no -o -z "$intercheck_pid" ] && return
   
   
   
   
   
   kill -15 $intercheck_pid >/dev/null 2>&1
   for i in 1 2 3 4 5 6 7 8 9 10; do
      sleep 1
      ps -p ${intercheck_pid} 2> /dev/null | egrep "^[ ]*${intercheck_pid} " | egrep "icheckd" 1> /dev/null 2> /dev/null
      if [ ${?} -ne 0 ]; then
         start_icheckd=yes
         fecho Successfully stopped InterCheck server based at "$configured_ic"
         return
      fi
   done
   fecho - Warning: Failed to stop InterCheck server "(PID" "$intercheck_pid)" based at "$intercheck_root"
}
checkPaths()
{
   
   
   
   
   
   
   
   
   
   
   fecho 1 "===>" Checking paths are accessible
   
   case $PATH in
   $bin_install_dir | $bin_install_dir:* | *:$bin_install_dir | *:$bin_install_dir:*)
      fecho 1 + '$PATH' is OK;;
   *) fecho - Warning: \$PATH does not include $bin_install_dir
      finalWarning=yes
      fecho 1 + To run Sophos Anti-Virus you need to set environment variable \$PATH so that it includes $bin_install_dir.
      fecho 1
   esac
   
   if [ "$platform" = "freebsd" ]; then
      
      inpath=yes
   elif [ $lib_install_dir = /usr/local/lib ] || [ "$lib_install_dir" = /usr/lib ] || [ "$lib_install_dir" = /lib ]; then
      inpath=yes
   elif [ "$isLinux" ] && [ -r /etc/ld.so.conf ] && grep "$lib_install_dir" /etc/ld.so.conf >/dev/null 2>&1; then
      inpath=yes
   else
      eval p=\$$libpathname
      case $p in
         $lib_install_dir | $lib_install_dir:* | *:$lib_install_dir | *:$lib_install_dir:*)
            inpath=yes;;
         *)
            inpath=
      esac
   fi
   if [ "$inpath" ]; then
      fecho 1 + Library path is OK
   else
      if [ "$isLinux" ]; then
         fecho - Warning: Neither \$$libpathname nor /etc/ld.so.conf include $lib_install_dir.
         fecho 1 + You need to either include an entry for $lib_install_dir in /etc/ld.so.conf, or set environment variable \$$libpathname to include $lib_install_dir or you will not be able to use Sophos Anti-Virus.
      else
         fecho Warning: \$$libpathname does not include $lib_install_dir.
         fecho 1 + You need to set environment variable \$$libpathname to include $lib_install_dir or you will not be able to use Sophos Anti-Virus.
      fi
      fecho 1
      finalWarning=yes
   fi
   
   if [ "$freebsd_ver" = 4 ]; then
      fecho - Warning: FreeBSD 4 and above: you may need to install the FreeBSD version 3.x compatibility libraries on your system.
      fecho
   fi
   
   if [ "$man_install_dir" = "/usr/man" ] || [ "$man_install_dir" = "/man" ]; then
      inpath=yes
   elif [ "$isLinux" ] && [ -r /etc/man.config ] && echo grep "$man_install_dir" /etc/man.config >/dev/null 2>&1; then
      inpath=yes
   else
      case "$MANPATH" in
      $man_install_dir | $man_install_dir:* | *:$man_install_dir | *:$man_install_dir:*)
         inpath=yes;;
      *)
         inpath=
      esac
   fi
   if [ "$inpath" ]; then
      fecho 1 + Manual path is OK
   else
      finalWarning=yes
      if [ "$isLinux" ]; then
         fecho - Warning: Neither \$MANPATH nor /etc/man.config include $man_install_dir.
         fecho 1 + You will not be able to read man pages for SWEEP or InterCheck using the man command unless you either include an entry for $man_install_dir in /etc/manpath.config, or set environment variable \$MANPATH to include $man_install_dir.
      else
         fecho - Warning: \$MANPATH does not include $man_install_dir.
         fecho 1 + You will not be able to read man pages for SWEEP or InterCheck using the man command unless you set environment variable \$MANPATH to include $man_install_dir.
      fi
      fecho 1
   fi
   
   if [ $install_intercheck = yes -a $intercheck_root != $configured_ic ]; then
      fecho - Warning: During installation you specified the InterCheck directory as "$intercheck_root." You must set the RootDirectory value in the file "$icheckd_conf."
      test ! -r $icheckd_conf && fecho + For more details on $icheckd_conf and its settings, consult the man pages on $icheckd_conf or the Sophos Anti-Virus manuals.
   fi
   
   if [ "$SAV_IDE" ] && [ "$SAV_IDE" != "$sav_install_dir" ]; then
      fecho - Warning: \$SAV_IDE is set to a directory other than "$sav_install_dir."
      fecho 1 + \$SAV_IDE overrides the setting in "$config_file" telling Sophos Anti-Virus where to find its virus data. Either unset this variable or set it to "$sav_install_dir."
      finalWarning=yes
   fi
   if [ "$finalWarning" ]; then
      if [ $verbose -eq 0 ]; then
         fecho If you need more details on these settings, run install with the -v option.
      else
         fecho Some environment variables may need to be set on your system. To make these settings permanent, add them to your login script or profile\; to make these settings systemwide, amend /etc/login or /etc/profile.
      fi
   fi
   return 
}
p=${0%/*}; 
[ "$p" ] && cd "$p"     
declareInitVariables    
scanCommandLine "$@"    
detectPlatform          
echo "Sophos Anti-Virus installation utility [$product_name]"
echo "Copyright (c) 1998,2001 Sophos Plc, Oxford, England"
echo
doAllPossibleChecks  
informUser
installBinaries
install_libsavi
install_vdl_dat         
installManuals
installIC
checkPaths
fecho 1 "===>" Installation complete "<==="
VAexit 0
